Subject: Re: [PATCH 1/6] sky2: fix hang on shutdown (and other irq issues)

From: Sven Joachim <[email-masked]>
Date: Thu, 17 Nov 2011 19:37:58 +0100

On 2011-11-17 18:01 +0100, Stephen Hemminger wrote:

> On Thu, 17 Nov 2011 09:46:43 +0100
> Sven Joachim <[email-masked]> wrote:
>
>> On 2011-11-17 00:42 +0100, Stephen Hemminger wrote:
>> 
>> > There are several problems with recent change to how IRQ's are setup.
>> >    * synchronize_irq in sky2_shutdown would hang because there
>> >      was no IRQ setup.
>> >    * when device was set to down, some IRQ bits left enabled so a
>> >      hardware error would produce IRQ with no handler
>> >    * quick link on Optima chip set was enabled without handler
>> >    * suspend/resume would leave IRQ on with no handler if device
>> >      was down
>> 
>> Unfortunately, this patch does not fix the hang at shutdown for me. :-(
>
> You are probably stuck in some part of the code path in sky2_shutdown.

Indeed.

> The best debug for this is sprinkling the code printk's. That is how I
> narrowed the problem down to synchronize_irq.

So I found out it's hanging in napi_disable() in sky2_all_down().  Not
being a kernel hacker, I don't know where to go from there.

Cheers,
       Sven